'\" t
.\"
.\" To properly format this file, you must use the -man troff macros and tbl
.\"
.\$Id: qmerge.man,v 1.9 2014/09/12 22:25:01 doug Exp $ 
.if n .na
.TH QMERGE 1 "29 August 2014" MINISEED
.SH NAME
qmerge - Create, merge, extract, or manipulate MiniSEED data files.
.SH SYNOPSIS
.na
.B qmerge
[\fB-o\ \fI output_file\fR \| \fB-n\fR]
[\fB-m\fR]
[\fB-a\fR]
[\fB-T\fR]
[\fB-f\ \fIdate\fR]
.if n .ti +5
[\fB-t\ \fIdate\fR \| \fB-s\ \fItime_span\fR]
[\fB-b\ \fIblksize\fR]
[\fB-e\fR]
[\fB-u\fR]
.if n .ti +5
[\fB-P\ \fIduration\fR]
.if t .ti +.5in
[\fB-p\fRn\ |\ \fB-p\fRd\]
.if n .ti +5
[\fB-g\ \fItolerance\fR]
[\fB-G\ \fItolerance\fR]
[\fB-V\ \fIversion\fR]
.if n .ti +5
[\fB-S\ \fIstation\fR]
[\fB-C\ \fIchannel\fR]
.if t .ti +.5in
[\fB-N\ \fInetwork\fR]
[\fB-L\ \fIlocation\fR]
.if n .ti +5
[\fB-x\ \fIblockette_list\fR\ |\ \fBall\fR]
.if n .ti +5
[\fB-i\ time\fR |\ \fBd0\fR |\ \fBno_d0\fR |\ \fBrate\fR |\ \fBdq\fR]
.if t .ti +.5in
[\fB-D\ j\ |\ m\fR]
[\fB-v\fR]
[\fB-c\fR]
[\fB-H\fR]
.if n .ti +5
[\fB-O\ \fIoutput_data_format\fR]
[\fB-I\ \fIinput_data_format\fR]
.if n .ti +5
[\fB-F\ \fIfile_list\fR]
[\fB-w\ \fIwordorder\fR]
.if t .ti +.5in
[\fB-d\ \fInum\fR]
[\fB-r\fR]
[\fB-R \fIrecord_type\fR]
[\fB-h\fR]
.if n .ti +5
[\fIinput_file_1\ ...\ input_file_n\fR]
.br
.ad
.SH DESCRIPTION
The 
.B qmerge
program performs data merging and data extraction operations on
single channel MiniSEED or Quanterra data files, or optionally
on a a single multichannel data file.
.B Qmerge 
can merge data from one or more Quanterra single channel input streams containing
overlapping or adjacent time intervals into a single output stream,
eliminating overlapping or redundant data.  The single output data stream
consists of MiniSEED or plain SEED data records with data
blocks that span the continuous time interval of all of the input data
streams.  
.B Qmerge
can also extract or output MiniSEED data for a specified time window.

The input file format can be MiniSEED, SEED data records,
Steim binary, or Adebahr DRM file formats.  The data encoding format can
be either STEIM1, STEIM2, INT_16, INT_24, INT_32, IEEE_FP_SP, or IEEE_FP_DP 
format as described in the FDSN SEED manual.  The output data format is the 
same as the input data format.  Input files with different data formats should
not be merged.  

The input data blocksize of the files can be any valid MiniSEED blocksize
from 512-byte to 8K-bytes.  By default, the output records will have a
blksize of 4K-bytes, but any valid MiniSEED blksize can be specified for
the output file on the command line.
.B qmerge
will coalesce multiple input records or split input data records data as necessary
in order to create the output file with the requested blksize.

.B Qmerge 
will normally only operate on files that contain data from a single data stream
(station, network, channel, and location).  If you have multiple channels of
data in an input file, you can first split multichannel data into multiple single 
channel data files using the program 
.B sdrsplit 
or
.B mssplit
.

.B Qmerge 
now has a multichannel option that can perform processing on a single
file that contains multiple data channels.
Certain options such as those that that override station, network, channel, 
and location codes are not valid in multichannel mode.  
.B Qmerge
will not eliminate overlapping or redundant data, or reorder data when
processing a multichannel data file.

All summary, error, and informational messages are now identified with
the full MiniSEED channel identifier in the format:
.br
.in +.5in
\fIstation.network.channel.location\fR
.br
.in -.5in
.br
If any component is blank, that component will appear as an empty string.

.B Qmerge
can be used for many different purposes. 
.br
1.  It may be used to
create a single continuous data stream from multipe input files that may
contain data from overlapping time intervals.  
.br
2.  It may be used to extract
data from one or more data files that contain data from consecutive time
intervals.  
.br
3.  It can be used to reblock the data into larger or smaller blocks. The
default output blocksize is 4K bytes, irregardless of the input blocksize.
You may explicitly specify the output blocksize to any valid blocksize (a
power of 2) from a minimum of 512 byte to a maximum of 8K bytes.
.br
4.  It can be used to convert data from one format to another format
(such as from STEIM2 to STEIM1 format).
.br
5.  It can be used to repack data into full MiniSEED records.  This function
is useful if the system that generated MiniSEED records did not completely
fill the MiniSEED records.  An example of such a system might be a real-time
data feed from a seismic station that generates 1 second packets of data.
.br
6.  In multichannel mode, it can be used to extract data for a specified
time interval from all input data channels, or simply to scan and report
on the channel and time intervals of a multichannel input file.

.B Qmerge
will automatically provide appropriate time tolerance values for deciding
when blocks can safely be merged together without loss of significant time
information, or the user may specify explicit time tolerance values.

.SH OPTIONS
.TP
\fB-o \fIoutput_file\fR
.br
specifies the name of the output file.  If no file is specified, output will
be written to stdout.
.TP
\fB-a\fR
specifies that output data should be appended to the specified output file
instead of overwriting the output file.
.TP
\fB-n\fR
specifies that no output files should be created.  This is equivalent to
specifying \fI/dev/null\fR as the output file.
.TP
\fB-m\fR
specifies multichannel mode.  Only a single input file can be specified,
but it may contain multiple data channels.
.TP
\fB-T\fR
.br
specifies that the output file should be trimmed to the exact time specified.
Otherwise, the output file will be trimmed to the closest input block
boundary.
.TP
\fB-f \fIdate\fR
.br
specifies a beginning (from) time window for which data is desired.  All
data before this time will be discarded.
.TP  
\fB-t \fIdate\fR
.br
specifies an end (to) time window for which data is desired.  
Only data preceeding this time will be output.  The \"to\"
point is non-inclusive, in that data will be output up to but not including
the final time.  The format for specifying the to and from dates are:
.nf
        yyyy-mm-ddThh:mm:ss.ffffff
        yyyy/mm/dd/hh:mm:ss.ffffff
        yyyy/mm/dd.hh:mm:ss.ffffff
        yyyy/mm/dd,hh:mm:ss.ffffff
        yyyy-dddThh:mm:ss.ffffff
        yyyy.ddd.hh:mm:ss.ffffff
        yyyy.ddd,hh:mm:ss.ffffff
        yyyy,ddd,hh:mm:ss.ffffff
.fi
where the first group of formats specify the year, month, day, and time, and the
second group format specifies year, day-of-year, and time.  All trailing components
of the time are optional, and if not specified, are assumed to be 0.
.TP
\fB-s \fItime_span\fR
specifies a time_span (duration) in either seconds, minutes, hours, days, or
months, and is an alternate way of specifying the end of a time interval.
The time_span is an integer followed immediately by the character 
\fBS\fR, \fBM\fR, \fBH\fR, \fBd\fR, or \fBm\fR.  Note that time designators
are upper case, and day designators are lower case.  If no character is
specified, seconds are assumed.  This option is mutually exclusive with the
\fB-t\fR option, and must be used with the \f\B-f\fR option.
.TP
\fB-e\fR
specifies that only data blocks with the data header activity event flags
turned on should be output.  Event activity flags are
ACTIVITY_BEGINNING_OF_EVENT, ACTIVITY_END_OF_EVENT, and
ACTIVITY_EVENT_IN_PROGRESS.
.TP
\fB-u\fR
specifies the unique data flag.  Assume ALL input data is unique,
and suppress the removal of apparent duplicate data caused
by apparent data overlaps between data records.
Use this option of you KNOW that all data is unique, especially
with PASSCAL data where apparent data gaps may appear at the same
time as input sequence numbers and STEIM compressor parameters
are reset.
.TP
\fB-P \fIduration\fR
specifies that the output should be partitioned into files of the
specified time_span.
The time_span is an integer followed immediately by the character 
\fBM\fR, \fBH\fR, \fBd\fR, or \fBm\fR.  Note that time designators
are upper case, and day designators are lower case.
The filenames for the output files files are based on the filename
template %S.%N.%C.D.%Y.%j.%T where the following string substitution
is performed.
.in +0.5i
.TS
l l
l l .
String	Replaced by
%S	Station name (upper case)
%s	Station name (lower case)
%N	Network name (upper case)
%n	Network name (lower case)
%C	Channel name (upper case)
%c	Channel name (lower case)
%L	Location name (upper case)
%l	Location name (lower case)
%Y	4 digit year (0000-9999)
%y	2 digit year (00-99)
%m	2 digit month (01-12)
%d	2 digit day of month (01-31)
%j	3 digit day of year (000-366)
%H	2 digit hour (00-23)
%M	2 digit minute (00-59)
%T	6 digit time (hhmmss)
.TE
.in -0.5i
.a
You may use the -o option to specify a new template name to be
used with the -P option.
.TP
\fB-p \fBn\fR | \fBd\fR
specifies that the date information for the partitioned file should
be derived either from the nominal partition time 
.RB ( n )
or on the time of the
first actual data 
.RB ( d ).  
The default is to derived from the partition
time information.
.TP
\fB-b \fIblksize\fR
specifies the blocksize of the output file.  The blocksize may be any
valid MiniSEED blocksize (ie a power of 2) between 512 and 8K bytes inclusive.
The default blocksize if 4K.  The blocksize may either be specified as
the number of bytes (eg 4096) or as a number of K bytes (eg 4K).
If a blocksize of 0 is specified, the program will use the blocksize
of the first used input record as the output blocksize.
.TP
\fB-g \fItolerance\fR
specifies the maximum time difference in ticks (1/10 msec) that is permitted
between adjacent blocks of input data to be merged into a single output block.
If the expected time of the next block differs by less than \fItolerance\fR ticks,
the block can be merged with the preceeding block into a single output block.
The timetag of the composite block will be taken from the original timetag
of the first data point in the block.  If this option is not used, and
appropriate tolerance value based on the sample rate of the data channel
(current .1 * sample interval) will be used.
.TP
\fB-G \fItolerance\fR
specifies the maximum time difference in ticks (1/10 msec) that is permitted
between adjacent blocks of input data to be considered continuous data.
If the expected time of the next block differs by \fItolerance\fR ticks or more,
the data is assumed to be non-continuous between the 2 data blocks.  
.B Qmerge
will report statistics for each continuous section of data, and will reset
to 1 the initial sequence number of each continuous group of data.  If this
option is not used, and appropriate tolerance value based on the sample rate
of the data channel (current .4 * sample interval) will be used.
.TP
\fB-V \fIversion_number\fR
specifies the SEED version number of the output file.  SEED version 2.2 does
not support the network field or blockette 1000.  SEED Version 2.3 requires
the network field and will generate blockette 1000, which describes the
format of the data.  A Version 2.3 file will by default contain a blockette
1000, and will therefore conform to the MiniSEED standard.
The default version is 2.3.  Valid versions are 2.2 and 2.3.
.TP
\fB-S \fIstation\fR
specifies the 5-character station code to be used in the output SEED data header.
This will override the station code in the input data.  This option should ONLY
be used if you want to rename the station in the output MiniSEED file.
.TP
\fB-C \fIchannel\fR
specifies the 3-character channel code to be used in the output SEED data header.
This will override the channel code in the input data.  This option should ONLY
be used if you want to rename the channel in the output MiniSEED file.
.TP
\fB-N \fInetwork\fR
specifies the 2-character network code in the SEED data header.
This field will be ignored for version 2.2 or below.  If no network field is
specified and none is contained in the input data, the default network "BK"
will be used.
.TP
\fB-L \fIlocation\fR
specifies the 2-character location code in the SEED data header.
If no location field is specified and none is contained in the input data, the
blank location code will be used.  This field is normally left blank.
.TP
\fB-x \fIblockette_list\ |\ \fBall\fR
specifies a list of blockettes that should be stripped out or removed from
the output data stream.  This can be used to strip blockette 1000 from the output
stream while maintaining a V 2.3 SEED data header.
The blockette list can be a comma-delimited list of numbers and may include a
span of blockettes, eg 200-500,1001.  The keyword "\fBall\fR"
specifies that all blockettes should be removed from the output data stream.
.TP
\fB-D\ j\ |\ m\fR
specifies that dates should be displayed in either julian (year-dayofyear)
or month (year-day-month) format.
The default is julian format.
.TP
\fB-i\ time\fR 
specifies that the time span header of a input SEED telemetry file or DRM file
should be ignored, and that the input file must be read in order to decide
whether it contains data for the requested time span.  This option should be
used only when the time span header of the input file contains an invalid timespan.
.TP
\fB-i\ d0\fR
specifies that discrepencies in the initial difference value in the first
block of a file or sequence should be silently fixed.  Otherwise, a warning
will be issued.  Discrepencies in initial difference values can arise during
the merging of 2 files with contiguous data that were independently created with
Steim compression.  If this option is used indiscriminately, valuable warning
messages about invalid data or time tears could be suppressed.
.TP
\fB-i\ no_d0\fR 
specifies that discrepencies in the initial difference value in the first
block of a file or sequence should not be fixed.  Otherwise, a warning will
be issued.  Discrepencies in initial difference values can arise during the
merging of 2 files with contiguous data that were independently created with
Steim compression.  If this option is used indiscriminately, valuable
warning messages about invalid data or time tears could be suppressed.
MiniSEED data from RefTek recorders may have new compression history
at the start of each raw RefTek file.
.TP
\fB-i\ rate\fR 
specifies that the sample rate of a input SEED telemetry file or DRM file
should be ignored when determining whether input records are from the
same data channel. This option should be used when there are small bit
not significant differences in the sample rate of the input data.
.TP
\fB-i\ dq\fR
specifies that the MiniSEED Data Quality flag (R,D,Q,M) should be ignored
when trying to select the best input file to use.
.TP
.B -v
verify the internal consistency of all STEIM compressed data frames and data records.
.TP
.B -c
write a content index to stdout consisting of the fields from the first input file:
.br
.in +.5in
\fIstation channel network location blksize\fR
.br
.in -.5in
Blank network and location fields will be replaced by the 2-character string
"\fB--\fR" as a token placeholder.
This option is useful for determining the station and channel of a file in shell
scripts.  Each of the fields is written as a separate token to make it easy
to use within shell scripts.  Note that the above order is DIFFERENT
from the standard order of \fIstation.network.channel.location\fR used by
other reporting messages from 
.BRqmerge .
This options supresses all data output.
.TP
.B -H
writes a content and timespan index to stdout for each input file in the format:
.br
.in +.5in
\fIstation.network.channel.location blksize starttime \fBto\fI endtime\fR
.br
.in -.5in
If the input file is not a SEED Telemetry volume (ie it does not contain
a SEED Volume Header with blockette 8), the timespan info will
be omitted, since no timespan header is available in MiniSEED files.
.TP
\fB-O \fIoutput_data_format\fR
Note that conversion from floating point format to integer
format may cause a significant loss of precision.
.TP
\fB-w \fIoutput_wordorder\fR
specifies the output data word order of the output MiniSEED records.
Valid wordorders are:
.nf
        0 = little endian (Intel/VAX) header and data.
        1 = big endian (SPARC/Motorola) header and data.
        h0 = little endian header.
        h1 = big endian header.
        d0 = little endian data.
        d1 = big endian data.
.fi
By default the output wordorder will be big-endian.
This option may be used multiple times to specify different
header and data word orders.
.TP
\fB-I \fIinput_data_format\fR
specifies the input data format for non-MiniSEED data records
(ie data records that do not contain a blockette 1000).
If not specified, the assumed data format for non-MiniSEED data records
is STEIM1.  Currently, valid formats are STEIM1, STEIM2, INT_16, INT_24,
or INT_32, IEEE_FP_SP, and IEEE_FP_DP.
.TP
\fB-F \fIfile_list\fR
specifies a file containing a list of input files to process.
.TP
\fB-d \fInum\fR
specifies debugging information should be displayed.  Current debugging
options are:
.nf
.ta 0.5i
	1 = time slews
	2 = time info
	4 = block info
	8 = block headers
	16 = flags
	32 = input stream
	64 = output stream
	1024 = output ASCII header line and data for each record.
	2048 = output ASCII with 1 hdr per contiguous data segment.
.fi
.ad
Multiple debugging options can be specified by adding the appropriate values
together.
.TP
.B -r
will unpack and repack the MiniSEED records in the desired output format and
blocksize.  If an output format is not specified, the output format will be
the same format as the first input record that is selected for output.
.TP
\fB-R \fIrecord_type\fR
will specify an explicit data quality record type to be used in the MiniSEED
record type field.
Valid data quality record types are:
.nf
.ta 0.5i
	D = Undetermined data quality (backwards compatible).
	R = Raw or Real-time data with no Quality Control.
	Q = QC-ed data processed by some Quality control procedure.
.fi
.ad
If this option is not specified, the output records will have the same
data quality record type as the input records.
.TP
.B -h
print out a simple help message with syntax and explaination 
of the options.
.TP
\fIinput_file_1\ ...\ input_file_n\fR
.br
specifies the input files to be read.  If no files are specified, 
data is read from stdin.
.SH EXAMPLES
.nf
1.  Extract data from 1 or more input files.

qmerge -f 2002.154,23:00 -s 2H -o BKS.LHZ.event \\
	/data/archive/bbdata/2002/2002.15[45]/BKS.BK.BHZ.D*

2.  Convert DRM files to SEED data records and merge dialup data.

qmerge -f 2002.155,00:00 -s 1d -o BKS.BK.BHZ.D.2002.155 \\
  /data/aq01/data/BKS/BHZ.D/* /data/aq01/dialup.stream/BKS.BHZ.D.2002.155*

3.  Create an ascii version of the output data for debugging or diagnostic purposes.

qmerge -d 1024 mseed.input > mseed.ascii

4.  Scan a single channel or multichannel MiniSEED file.

qmerge -n singlechannel_mseed_file
qmerge -n -m multichannel_mseed_file

5.  Extract selected time window from a multichannel MiniSEED file.

qmerge -m -f 2014-08-29T15:34 -s 3M -o multichannel_miniseed_file > subset_file

.SH SEE ALSO
sdrsplit(1)

.SH BUGS
1.  The order of channel identifiers from the
.B -c
option is different than the order used by all other informational messages.
This is to preserve backwards compatibility with older versions of 
.BR qmerge .

.SH AUTHOR
Doug Neuhauser, UC Berkeley Seismological Laboratory, doug@seismo.berkeley.edu.
